unit WebModuleUnit1;

interface

uses System.SysUtils, System.Classes, Web.HTTPApp,
     datamodule,
     VCL.FlexCel.Core, FlexCel.XlsAdapter, FlexCel.Report, FlexCel.Render;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1DefaultHandlerAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TWebModule1.WebModule1DefaultHandlerAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  Report: TFlexCelReport;
  Xls: TExcelFile;
  Ts: TMemoryStream;
  Pdf: TFlexCelPdfExport;
begin
  Report := TFlexCelReport.Create(true);
  try
    Report.AddTable('data', datamodule1.data);

    Xls := TXlsFile.Create('..\..\..\why.xls', true);
    try
      Ts := TMemoryStream.Create();
      try
        Report.Run(Xls);
        Pdf := TFlexCelPdfExport.Create(Xls, true);
        try
          Pdf.BeginExport(Ts);
          Pdf.ExportSheet;
          Pdf.EndExport;
        finally
          Pdf.Free;
        end;

        Response.SendStream(Ts);
      finally
        Ts.Free;
      end;
    finally
      Xls.Free;
    end;
  finally
    Report.Free;
  end;

end;

end.
