unit Unit5;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.StdCtrls, WEBLib.StdCtrls, WEBLib.REST, Vcl.Controls, WEBLib.ExtCtrls;

type
  TForm1 = class(TWebForm)
    WebHTMLContainer1: TWebHTMLContainer;
    WebHttpRequest1: TWebHttpRequest;
    WebButton1: TWebButton;
    procedure WebButton1Click(Sender: TObject);
    procedure WebHttpRequest1Response(Sender: TObject; AResponse: string);
  published
    procedure OpenDetail(const Date: integer);
    procedure OpenMaster;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.WebButton1Click(Sender: TObject);
begin
  WebHttpRequest1.URL := 'http://localhost:8084';
  WebHttpRequest1.Execute;
  WebButton1.Enabled := false;
end;

procedure TForm1.OpenDetail(const Date: integer);
begin
  WebHttpRequest1.URL := 'http://localhost:8084/detail?day=' + IntToStr(Date);
  WebHttpRequest1.Execute;
  WebButton1.Enabled := false;
end;

procedure TForm1.OpenMaster;
begin
  WebHttpRequest1.URL := 'http://localhost:8084';
  WebHttpRequest1.Execute;
  WebButton1.Enabled := false;
end;

procedure TForm1.WebHttpRequest1Response(Sender: TObject; AResponse: string);
var
 cssPos: integer;
 cssString: string;
 innerCssStart, innerCssEnd: integer;
begin
  WebButton1.Enabled := true;
  cssPos := Pos(#0#0#0#0, AResponse);
  if (cssPos < 1) then
  begin
    ShowMessage('Invalid response from server');
  end;

  WebHTMLContainer1.HTML.Text := copy(AResponse, cssPos + 4, Length(AResponse));
  cssString := copy(AResponse, 1, cssPos - 1);
  innerCssStart := pos('>', cssString) + 1;
  innerCssEnd := pos('</style>', cssString);
  {$IFDEF WIN32}
  ShowMessage(copy(cssString, innerCssStart, innerCssEnd - innerCssStart));
  {$ELSE}
  WebHTMLContainer1.AddInstanceStyle(copy(cssString, innerCssStart, innerCssEnd - innerCssStart));
  {$ENDIF}
end;

end.